// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v5.29.2
// source: api/container/grpc/service.proto

package container

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	ContainerService_Put_FullMethodName        = "/neo.fs.v2.container.ContainerService/Put"
	ContainerService_Delete_FullMethodName     = "/neo.fs.v2.container.ContainerService/Delete"
	ContainerService_Get_FullMethodName        = "/neo.fs.v2.container.ContainerService/Get"
	ContainerService_List_FullMethodName       = "/neo.fs.v2.container.ContainerService/List"
	ContainerService_ListStream_FullMethodName = "/neo.fs.v2.container.ContainerService/ListStream"
)

// ContainerServiceClient is the client API for ContainerService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// `ContainerService` provides API to interact with `Container` smart contract
// in FrostFS sidechain via other FrostFS nodes. All of those actions can be
// done equivalently by directly issuing transactions and RPC calls to sidechain
// nodes.
type ContainerServiceClient interface {
	// `Put` invokes `Container` smart contract's `Put` method and returns
	// response immediately. After a new block is issued in sidechain, request is
	// verified by Inner Ring nodes. After one more block in sidechain, the
	// container is added into smart contract storage.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     request to save the container has been sent to the sidechain;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     container create access denied.
	Put(ctx context.Context, in *PutRequest, opts ...grpc.CallOption) (*PutResponse, error)
	// `Delete` invokes `Container` smart contract's `Delete` method and returns
	// response immediately. After a new block is issued in sidechain, request is
	// verified by Inner Ring nodes. After one more block in sidechain, the
	// container is added into smart contract storage.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     request to remove the container has been sent to the sidechain;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     container delete access denied.
	Delete(ctx context.Context, in *DeleteRequest, opts ...grpc.CallOption) (*DeleteResponse, error)
	// Returns container structure from `Container` smart contract storage.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     container has been successfully read;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_NOT_FOUND** (3072, SECTION_CONTAINER): \
	//     requested container not found;
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     access to container is denied.
	Get(ctx context.Context, in *GetRequest, opts ...grpc.CallOption) (*GetResponse, error)
	// Returns all owner's containers from `Container` smart contract storage.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     container list has been successfully read;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     container list access denied.
	List(ctx context.Context, in *ListRequest, opts ...grpc.CallOption) (*ListResponse, error)
	// Returns all owner's containers from `Container` smart contract storage
	// via stream.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     container list has been successfully read;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     container list access denied.
	ListStream(ctx context.Context, in *ListStreamRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[ListStreamResponse], error)
}

type containerServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewContainerServiceClient(cc grpc.ClientConnInterface) ContainerServiceClient {
	return &containerServiceClient{cc}
}

func (c *containerServiceClient) Put(ctx context.Context, in *PutRequest, opts ...grpc.CallOption) (*PutResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(PutResponse)
	err := c.cc.Invoke(ctx, ContainerService_Put_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *containerServiceClient) Delete(ctx context.Context, in *DeleteRequest, opts ...grpc.CallOption) (*DeleteResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(DeleteResponse)
	err := c.cc.Invoke(ctx, ContainerService_Delete_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *containerServiceClient) Get(ctx context.Context, in *GetRequest, opts ...grpc.CallOption) (*GetResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetResponse)
	err := c.cc.Invoke(ctx, ContainerService_Get_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *containerServiceClient) List(ctx context.Context, in *ListRequest, opts ...grpc.CallOption) (*ListResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ListResponse)
	err := c.cc.Invoke(ctx, ContainerService_List_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *containerServiceClient) ListStream(ctx context.Context, in *ListStreamRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[ListStreamResponse], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &ContainerService_ServiceDesc.Streams[0], ContainerService_ListStream_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[ListStreamRequest, ListStreamResponse]{ClientStream: stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type ContainerService_ListStreamClient = grpc.ServerStreamingClient[ListStreamResponse]

// ContainerServiceServer is the server API for ContainerService service.
// All implementations should embed UnimplementedContainerServiceServer
// for forward compatibility.
//
// `ContainerService` provides API to interact with `Container` smart contract
// in FrostFS sidechain via other FrostFS nodes. All of those actions can be
// done equivalently by directly issuing transactions and RPC calls to sidechain
// nodes.
type ContainerServiceServer interface {
	// `Put` invokes `Container` smart contract's `Put` method and returns
	// response immediately. After a new block is issued in sidechain, request is
	// verified by Inner Ring nodes. After one more block in sidechain, the
	// container is added into smart contract storage.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     request to save the container has been sent to the sidechain;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     container create access denied.
	Put(context.Context, *PutRequest) (*PutResponse, error)
	// `Delete` invokes `Container` smart contract's `Delete` method and returns
	// response immediately. After a new block is issued in sidechain, request is
	// verified by Inner Ring nodes. After one more block in sidechain, the
	// container is added into smart contract storage.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     request to remove the container has been sent to the sidechain;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     container delete access denied.
	Delete(context.Context, *DeleteRequest) (*DeleteResponse, error)
	// Returns container structure from `Container` smart contract storage.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     container has been successfully read;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_NOT_FOUND** (3072, SECTION_CONTAINER): \
	//     requested container not found;
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     access to container is denied.
	Get(context.Context, *GetRequest) (*GetResponse, error)
	// Returns all owner's containers from `Container` smart contract storage.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     container list has been successfully read;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     container list access denied.
	List(context.Context, *ListRequest) (*ListResponse, error)
	// Returns all owner's containers from `Container` smart contract storage
	// via stream.
	//
	// Statuses:
	//   - **OK** (0, SECTION_SUCCESS): \
	//     container list has been successfully read;
	//   - Common failures (SECTION_FAILURE_COMMON);
	//   - **CONTAINER_ACCESS_DENIED** (3074, SECTION_CONTAINER): \
	//     container list access denied.
	ListStream(*ListStreamRequest, grpc.ServerStreamingServer[ListStreamResponse]) error
}

// UnimplementedContainerServiceServer should be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedContainerServiceServer struct{}

func (UnimplementedContainerServiceServer) Put(context.Context, *PutRequest) (*PutResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Put not implemented")
}
func (UnimplementedContainerServiceServer) Delete(context.Context, *DeleteRequest) (*DeleteResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedContainerServiceServer) Get(context.Context, *GetRequest) (*GetResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedContainerServiceServer) List(context.Context, *ListRequest) (*ListResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedContainerServiceServer) ListStream(*ListStreamRequest, grpc.ServerStreamingServer[ListStreamResponse]) error {
	return status.Errorf(codes.Unimplemented, "method ListStream not implemented")
}
func (UnimplementedContainerServiceServer) testEmbeddedByValue() {}

// UnsafeContainerServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ContainerServiceServer will
// result in compilation errors.
type UnsafeContainerServiceServer interface {
	mustEmbedUnimplementedContainerServiceServer()
}

func RegisterContainerServiceServer(s grpc.ServiceRegistrar, srv ContainerServiceServer) {
	// If the following call pancis, it indicates UnimplementedContainerServiceServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&ContainerService_ServiceDesc, srv)
}

func _ContainerService_Put_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PutRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContainerServiceServer).Put(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ContainerService_Put_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContainerServiceServer).Put(ctx, req.(*PutRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContainerService_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContainerServiceServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ContainerService_Delete_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContainerServiceServer).Delete(ctx, req.(*DeleteRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContainerService_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContainerServiceServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ContainerService_Get_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContainerServiceServer).Get(ctx, req.(*GetRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContainerService_List_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContainerServiceServer).List(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ContainerService_List_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContainerServiceServer).List(ctx, req.(*ListRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContainerService_ListStream_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(ListStreamRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ContainerServiceServer).ListStream(m, &grpc.GenericServerStream[ListStreamRequest, ListStreamResponse]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type ContainerService_ListStreamServer = grpc.ServerStreamingServer[ListStreamResponse]

// ContainerService_ServiceDesc is the grpc.ServiceDesc for ContainerService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ContainerService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "neo.fs.v2.container.ContainerService",
	HandlerType: (*ContainerServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Put",
			Handler:    _ContainerService_Put_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _ContainerService_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _ContainerService_Get_Handler,
		},
		{
			MethodName: "List",
			Handler:    _ContainerService_List_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "ListStream",
			Handler:       _ContainerService_ListStream_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "api/container/grpc/service.proto",
}
