package session

import (
	session "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/session/grpc"
)

// String returns string representation of ObjectSessionVerb.
func (x ObjectSessionVerb) String() string {
	return ObjectSessionVerbToGRPCField(x).String()
}

// FromString parses ObjectSessionVerb from a string representation.
// It is a reverse action to String().
//
// Returns true if s was parsed successfully.
func (x *ObjectSessionVerb) FromString(s string) bool {
	g, ok := session.ObjectSessionContext_Verb_value[s]

	if ok {
		*x = ObjectSessionVerbFromGRPCField(session.ObjectSessionContext_Verb(g))
	}

	return ok
}

// String returns string representation of ContainerSessionVerb.
func (x ContainerSessionVerb) String() string {
	return ContainerSessionVerbToGRPCField(x).String()
}

// FromString parses ContainerSessionVerb from a string representation.
// It is a reverse action to String().
//
// Returns true if s was parsed successfully.
func (x *ContainerSessionVerb) FromString(s string) bool {
	g, ok := session.ContainerSessionContext_Verb_value[s]

	if ok {
		*x = ContainerSessionVerbFromGRPCField(session.ContainerSessionContext_Verb(g))
	}

	return ok
}
